

package org.easyFS;

import java.io.IOException;
import java.nio.ByteBuffer;
import java.nio.CharBuffer;
import java.util.Date;
import java.util.HashMap;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;


import fuse.Errno;
import fuse.Filesystem3;
import fuse.FuseDirFiller;
import fuse.FuseException;
import fuse.FuseFtype;
import fuse.FuseGetattrSetter;
import fuse.FuseOpenSetter;
import fuse.FuseStatfsSetter;


public class EasyFSFUSEFileSystem implements Filesystem3 {


	private long BLOCK_SIZE = 8096;
	private long NAME_LENGTH = 2048;
	
	private String clearCache = ".cache";
	
	//private static final Log log = LogFactory.getLog();
	
	public EasyFSFUSEFileSystem(String uname,String pass)
	{
		
			try {
				EasyFSBD.Connect(uname, pass);
				
			} catch (Exception e) {
				e.printStackTrace();
			}
			
			
		
	}
	
	
	public int chmod(String arg0, int arg1) throws FuseException {
		return Errno.ENOTSUPP;
	}
	public int chown(String arg0, int arg1, int arg2) throws FuseException {
		return Errno.ENOTSUPP;
	}
	public int flush(String path, Object fh ) throws FuseException {
		return 0;
	}
	public int fsync(String arg0, Object arg1, boolean arg2) throws FuseException {
		return 0;
	}
	
	public int getattr(String path, FuseGetattrSetter at) throws FuseException {
					return Errno.ENOENT; 
		}
	


	public int getdir(String path, FuseDirFiller fd) throws FuseException {	
		return 0;
	}
	
	
	
	public int link(String arg0, String arg1) throws FuseException {
		return Errno.ENOTSUPP;
	}
	public int mkdir(String path, int mode) throws FuseException {
//		EasyFSPathDecoder dec = new EasyFSPathDecoder(path);
//		
//			try {
//				createDirectory(dec);
//			} catch (Exception e) {
//				log.error("mkdir:",e);
//				return Errno.EIO;
//			}
//			return Errno.EAFNOSUPPORT;
			return 0;
	}
	
	public int mknod(String path, int mode, int rdev) throws FuseException{
		    

			 return Errno.ENOTSUPP;
		

	}
	public int open(String path, int type, FuseOpenSetter fs) throws FuseException {
		try{
		
				fs.setDirectIO(true);
				fs.setKeepCache(true);
				return 0;
			}
		
		catch(Exception e)
		{
			
			return Errno.EBADF;
		}
		
	}
	public int read(String path, Object fh,  ByteBuffer buf, long offset) throws FuseException {

		//try {
		//	h.read(buf, offset);
		//} 
//		catch (IOException e) {
//			return Errno.EIO;
//		}
		return 0;
	}
	public int readlink(String arg0, CharBuffer arg1) throws FuseException {
		return Errno.ENOTSUPP;
	}
	public int release(String path, Object fh, int type) throws FuseException {
//		try {
//			
//		} catch (IOException e) {
//			e.printStackTrace();
//			return Errno.EIO;
//		}
//		catch (ServiceException e) {
//			log.error("Release: " ,e);
	return Errno.EIO;
//		}
//		return 0;
	}
	public int rename(String fromPath, String toPath) throws FuseException {
		System.err.println("RENAME: " + fromPath + " - " + toPath );

			//try {
				//cache.clear();
				return 0;
			//} 
			//catch (ServiceException e) {
				//return Errno.EIO;
			//} catch (IOException e) {
				//return Errno.EIO;
			//}
	
		
		//return Errno.ENOTSUPP;
	}
	
	public int rmdir(String path) throws FuseException {
		
			
				//return Errno.EIO;
	
			return Errno.ENOTSUPP;
		//return 0;
	}
	public int statfs(FuseStatfsSetter fs) throws FuseException {
		//try {
			//UserData udata = cache.getUserData();
			//int max = (int)(udata.getQuotaLimit() / BLOCK_SIZE);
			//int used = (int)(udata.getQuotaUsed() / BLOCK_SIZE);;
			//int free = max -used;
			//System.err.println("FREE: " + free);
//			fs.set(
//					(int)BLOCK_SIZE,
//					max,
//					free,
//					-1,
//					udata.getMaxPhotos(),
//					udata.getMaxPhotos(),
//					(int)NAME_LENGTH);
//		} catch (IOException e) {
//			log.error("statfs:",e );
//			return Errno.EIO;
//		} catch (ServiceException e) {
//			
//			log.error("statfs:",e );
//			return Errno.EIO;
			
		return 0;
	}
	public int symlink(String arg0, String arg1) throws FuseException {
		return Errno.ENOTSUPP;
	}
	public int truncate(String arg0, long arg1) throws FuseException {
		return Errno.ENOTSUPP;
	}
	public int unlink(String path) throws FuseException {
			//return 0;
		
			return Errno.ENOTSUPP;
	}
	public int utime(String arg0, int arg1, int arg2) throws FuseException {
		return Errno.ENOTSUPP;
	}
	public int write(String path, Object fh, boolean iswritepage, ByteBuffer buf, long offset) throws FuseException {
		
//		try {
//			h.write(buf, offset);
//		} catch (IOException e) {
//			e.printStackTrace();
//			return Errno.EIO;
//		}
		return 0;
		
	}
	
	
	
	
	
}
